Bug 1295030 - JDownloader2 causes fatal JRE error under XWayland
JDownloader2 causes fatal JRE error under XWayland
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: mutter (Show other bugs)
25
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Florian Müllner
Fedora Extras Quality Assurance
:
Depends On:
Blocks: WaylandRelated
  Show dependency treegraph
 
Reported: 2015-12-31 23:35 EST by smitna
Modified: 2017-12-12 06:08 EST (History)
11 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-12-12 06:08:14 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
JRE error log (76.54 KB, text/plain)
2015-12-31 23:35 EST, smitna
no flags Details

  None (edit)
Description smitna 2015-12-31 23:35:54 EST
Created attachment 1110883 [details]
JRE error log

Description of problem:
See Summary.


Version-Release number of selected component (if applicable):
Name        : xorg-x11-server-Xwayland
Version     : 1.18.0
Release     : 2.fc23
Architecture: x86_64

Name        : java-1.8.0-openjdk
Epoch       : 1
Version     : 1.8.0.65
Release     : 13.b17.fc23
Architecture: x86_64


Steps to Reproduce:

1)  Start a GNOME/Wayland session.

2)  Download:  http://installer.jdownloader.org/JD2Setup_x64.sh

3)  Run installer from #2 as a non-root user, and accept all defaults but decline to run JDownloader at final step.

4)  Installer should have created ~/jd2.  Remove or rename ~/jd2/jre.  This will force use of system JRE which should have been installed from standard Fedora repos.

5)  Run:  ~/jd2/JDownloader2


Actual results:

1)  abnormal termination detected by ABRT but backtraces generated both locally and remotely are unusable.

2)  ABRT report:  https://retrace.fedoraproject.org/faf/reports/952316/

3)  JRE generates it own error log (see attachment).
NOTE:  although similar, this error log DOES NOT correspond exactly to the ABRT report from #2.


Additional info:

1)  Faulting application requires X11; i.e. substituting the command from step #5 with this one results in an error about DISPLAY value:
$ DISPLAY='' ~/jd2/JDownloader2

2)  This problem does NOT occur under weston with xwayland.so module loaded;
e.g. when ~/.config/weston.ini contains exactly the following 2 lines:
[core]
modules=xwayland.so

3)  Similar problem also occurs with bundled JRE (disabled in "Steps to Reproduce" #4)
Comment 1 Kamil Páral 2016-01-04 04:38:10 EST
So, IIUIC, JDownloader2 crashes under GNOME+Wayland, but it does not crash under Weston+xwayland.so?
Comment 2 smitna 2016-01-09 15:10:41 EST
Comment #1 (by Kamil) is exactly correct.

Note:  a JRE update was released since this report was initially submitted:

Name        : java-1.8.0-openjdk
Epoch       : 1
Version     : 1.8.0.65
Release     : 15.b17.fc23 (was 13.b17.fc23)
Architecture: x86_64

However, after applying this and all other pending updates, the crash still occurs.
Comment 3 Kamil Páral 2016-01-11 03:49:29 EST
Since this works under Weston, moving to mutter. According to the traceback, this is probably related to system tray support.
Comment 4 smitna 2016-01-11 22:25:53 EST
Thanks for your attention to this Kamil.

You seem to be on the right track in Comment 3:  I disabled tray support in JDownloader from a GNOME/X11 session, and it did NOT crash afterwards when I launched it from a GNOME/Wayland session.
Comment 5 J. Haas 2016-02-22 03:47:31 EST
Well, the root problem is that the tray icon module calls

java.awt.Robot#getPixelColor
sun.awt.X11.XRobotPeer#getRGBPixel

which calls into native code:

sun.awt.X11.XRobotPeer#getRGBPixelsImpl

which seems to want to create a screen shot of the X11 root window:

https://github.com/frohoff/jdk8u-jdk/blob/master/src/solaris/native/sun/awt/awt_Robot.c#L204 (not the official repository, but whatever)

So this is probably a Java issue. Java shouldn't crash if it's unable to screen shot other windows. Unfortunately the API doesn't really support good error handling there. JDownloader2 probably needs to be fixed, too.
Comment 6 Christian Stadelmann 2016-09-28 16:23:45 EDT
I think this is a duplicate of bug #1264512.
Comment 7 J. Haas 2016-09-29 04:57:21 EDT
I don't think so. This bug is caused by openjdk not being (x)wayland compatible, bug #1264512 seems to be unrelated to wayland. Stacktraces look different to me.
Comment 8 Fedora End Of Life 2016-11-24 09:38:16 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 Mariusz Smykuła 2016-12-02 16:25:13 EST
This bug is still valid for Fedora 25
Comment 10 Mariusz Smykuła 2016-12-02 16:25:25 EST
This bug is still valid for Fedora 25
Comment 11 J. Haas 2017-10-25 05:47:09 EDT
This should be fixed in JDK 9 because they now use the gtk API to take screenshots if available: http://hg.openjdk.java.net/jdk9/client/jdk/file/947ed8e207b5/src/java.desktop/unix/native/libawt_xawt/awt/awt_Robot.c#l340
Comment 12 Fedora End Of Life 2017-11-16 14:23:35 EST
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 13 Fedora End Of Life 2017-12-12 06:08:14 EST
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.